
/** Una BoundedQueue  una coda di dimensione limitata fissata a priori. */

public class BoundedQueue implements Queue {

	 /** Array che contiene gli oggetti. */
	 private Object a[];
	 /** Numero di oggetti in coda. */
	 private int size;
	 /** Primo oggetto in ocda (valido solo se size>0). */
	 private int first;

	 public BoundedQueue( int dim ) {
		  a = new Object[dim];
		  size = first = 0;
	 }

	 public synchronized void enqueue( Object o ) {
		  while ( size == a.length ) 
				try {
					 this.wait();
				} catch ( InterruptedException e ) { return; }
		  a[(first+size) % a.length] = o;
		  size++;
		  this.notifyAll();
	 }

	 public synchronized Object dequeue() {
		  while ( size == 0 ) 
				try {
					 this.wait();
				} catch ( InterruptedException e ) { return null; }
		  Object res = a[first];
		  first = ( first + 1 ) % a.length;
		  size--;
		  this.notifyAll();
		  return res;
	 }

	 public boolean isEmpty() {
		  return ( size == 0 );
	 }

}
