
/** Un Consumer  un thread associato a una coda. Il thread non termina mai, e 
 *  ogni volta legge un oggetto dalla coda e lo stampa. Se la coda  vuota, aspetta
 *  finch non c' almeno un elemento. Quindi aspetta un tempo casuale
 *  fra 0 e un numero dato di millisecondi.
 */

public class Consumer extends Thread {
	 
	 /** Coda da cui il thread legge. */
	 private Queue q;
	 /** Millisecondi massimi di attesa. */
	 private int maxWait;

	 public Consumer( Queue q, int maxWait ) {
		  this.q = q;
		  this.maxWait = maxWait;
	 }

	 public void run() {
		  while( true ) {
				Object o = q.dequeue();
				System.out.print( o );
				// Ora aspetta
				try {
					 Thread.currentThread().sleep( (int) Math.random()*maxWait );
				} catch ( InterruptedException e ) {
					 break;
				}
		  }
	 }

}
