
public class ContatoreNonNegativo {

	private int conta;
	
	public ContatoreNonNegativo() {
		conta = 0;
	}
	
	public synchronized void inc() {
		int incrementato;
		System.out.println( "Incremento il contatore che vale " + conta );
		incrementato = conta + 1;
		conta = incrementato;
		this.notifyAll();
	}

	public synchronized void dec() {
		int decrementato;
		System.out.println( "Decremento il contatore che vale " + conta );
		while ( conta == 0 )
			try {
				System.out.println( "In attesa di decremento..." );
				this.wait();
			}
			catch ( InterruptedException e ) {
				return;
			}
		System.out.println( "Fuori dall'attesa: il contatore vale " + conta );
		decrementato = conta - 1;
		conta = decrementato;
	}
	
	public synchronized int valore() {
		return conta;
	}
	
}